use wordlelike::*;
use wordlelike::guess::*;

fn play<const N: usize>(dictionary: &Dictionary<N>) {
    let mut constraints = constraints::Total::new();
    let mut rng = rand::thread_rng();
    let mut game = game::Game {
        evaluator: &mut evaluator::AdversarialEvaluator::new(dictionary),
        guesser: &mut guesser::RandomConstraintGuesser::new(dictionary, &mut constraints, &mut rng),
    };
    loop {
        let result = game.play_round();
        println!("{}", result);
        if result.correct() {
            return
        }
        game.push(result);
    }
}

fn main() {
    let common_words: Vec<Word<5>> = load::load_words(include_str!("words/common.txt"));
    loop {
        play(&common_words);
    }
}
